import csv
import numpy as np
import matplotlib
import matplotlib.pyplot as plt
import pandas as pd
import scipy.stats
import matplotlib.patches as mpatches

########################################################################################################################

periods = ['_1985_1989', '_1990_1994', '_1995_1999', '_2000_2004', '_2005_2009', '_2010_2014', '_2015_2019']

# Attribute Tables (AT) file name list
AT_fn_list = ('Clustering_attribute_table_1985_1989.csv'
              , 'Clustering_attribute_table_1990_1994.csv'
              , 'Clustering_attribute_table_1995_1999.csv'
              , 'Clustering_attribute_table_2000_2004.csv'
              , 'Clustering_attribute_table_2005_2009.csv'
              , 'Clustering_attribute_table_2010_2014.csv'
              , 'Clustering_attribute_table_2015_2019.csv'
              )

# Read Attribute Tables into dataframes

with open(AT_fn_list[0], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_1985_1989 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_1985_1989.Cluster = df_1985_1989.Cluster.astype(int)
df_1985_1989.ID = df_1985_1989.ID.astype(int)

with open(AT_fn_list[1], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_1990_1994 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_1990_1994.Cluster = df_1990_1994.Cluster.astype(int)
df_1990_1994.ID = df_1990_1994.ID.astype(int)

with open(AT_fn_list[2], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_1995_1999 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_1995_1999.Cluster = df_1995_1999.Cluster.astype(int)
df_1995_1999.ID = df_1995_1999.ID.astype(int)

with open(AT_fn_list[3], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_2000_2004 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_2000_2004.Cluster = df_2000_2004.Cluster.astype(int)
df_2000_2004.ID = df_2000_2004.ID.astype(int)

with open(AT_fn_list[4], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_2005_2009 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_2005_2009.Cluster = df_2005_2009.Cluster.astype(int)
df_2005_2009.ID = df_2005_2009.ID.astype(int)

with open(AT_fn_list[5], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_2010_2014 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_2010_2014.Cluster = df_2010_2014.Cluster.astype(int)
df_2010_2014.ID = df_2010_2014.ID.astype(int)

with open(AT_fn_list[6], 'r') as f:
    Attribute_table = list(csv.reader(f, delimiter=","))
Attribute_table = np.array(Attribute_table[1:], dtype=np.float)

df_2015_2019 = pd.DataFrame(Attribute_table, columns=["ID", "Mean\nelevation (m)", "Mean\nslope (°)"
                                                                   , "Mean\nNDVI", "NDVI fractional\ncoverage (%)"
                                                                   , "Mean\nNDMI", "NDWI fractional\ncoverage (%)"
                                                                   , "Thaw-stable\nsurface deposits\ncover (%)"
                                                                   , "Thaw-unstable\nsurface deposits\ncover (%)"
                                                                   , "Drainage\ndensity", "Form\nfactor", "Membership1"
                                                                   , "Membership2", "Cluster"])
df_2015_2019.Cluster = df_2015_2019.Cluster.astype(int)
df_2015_2019.ID = df_2015_2019.ID.astype(int)

########################################################################################################################

# Annual Mean Temperature (AMT) file name list
AMT_fn_list = ('TempMoyBRG1.csv', 'TempMoyBRG2.csv', 'TempMoyBRG3.csv', 'TempMoyBRG4.csv')

# Read AMT into dataframes
AMT_dfs = []
for i in AMT_fn_list:
    df = pd.read_csv(i)
    df.index = pd.to_datetime(df['DateTime'])
    df = df[(df['DateTime'] >= '1985-01-01') & (df['DateTime'] < '2022-01-01')]
    df = df.drop(columns=['DateTime'
                          , 'RCP 2.6 médiane'
                          , 'RCP 2.6 portée (low)'
                          , 'RCP 2.6 portée (high)'
                          , 'RCP 8.5 médiane'
                          , 'RCP 8.5 portée (low)'
                          , 'RCP 8.5 portée (high)'
                          ])
    AMT_dfs.append(df)

AMT_df1 = AMT_dfs[0]
AMT_df2 = AMT_dfs[1]
AMT_df3 = AMT_dfs[2]
AMT_df4 = AMT_dfs[3]

#print('Annual Mean Temperature :\n', AMT_dfs[0], '\n')

########################################################################################################################

# Annual Total Precipitation (ATP) file name list
ATP_fn_list = ('PrecipTotBRG1.csv', 'PrecipTotBRG2.csv', 'PrecipTotBRG3.csv', 'PrecipTotBRG4.csv')

# Read ATP into dataframes
ATP_dfs = []
for i in ATP_fn_list:
    df = pd.read_csv(i)
    df.index = pd.to_datetime(df['DateTime'])
    df = df[(df['DateTime'] >= '1985-01-01') & (df['DateTime'] < '2021-01-01')]
    df = df.drop(columns=['RCP 2.6 médiane'
                          , 'RCP 2.6 portée (low)'
                          , 'RCP 2.6 portée (high)'
                          , 'RCP 8.5 médiane'
                          , 'RCP 8.5 portée (low)'
                          , 'RCP 8.5 portée (high)'
                          ])
    ATP_dfs.append(df)

ATP_df1 = ATP_dfs[0]
ATP_df2 = ATP_dfs[1]
ATP_df3 = ATP_dfs[2]
ATP_df4 = ATP_dfs[3]

#print('Annual Total Precipitation :\n', ATP_dfs[0], '\n')

########################################################################################################################

# Merge into 1 Dataframe

date_index_y = pd.date_range('2/1/1984', periods=36, freq='YS')

df = pd.DataFrame({
    'AMT_B1_mean': AMT_df1['Historique modélisé'],
    'AMT_B1_min': AMT_df1['Répartition historique (low)'],
    'AMT_B1_max': AMT_df1['Répartition historique (high)'],
    'AMT_B1_RCP_median': AMT_df1['RCP 4.5 médiane'],
    'AMT_B1_RCP_min': AMT_df1['RCP 4.5 portée (low)'],
    'AMT_B1_RCP_max': AMT_df1['RCP 4.5 portée (high)'],
    'AMT_B2_mean': AMT_df2['Historique modélisé'],
    'AMT_B2_min': AMT_df2['Répartition historique (low)'],
    'AMT_B2_max': AMT_df2['Répartition historique (high)'],
    'AMT_B2_RCP_median': AMT_df2['RCP 4.5 médiane'],
    'AMT_B2_RCP_min': AMT_df2['RCP 4.5 portée (low)'],
    'AMT_B2_RCP_max': AMT_df2['RCP 4.5 portée (high)'],
    'AMT_B3_mean': AMT_df3['Historique modélisé'],
    'AMT_B3_min': AMT_df3['Répartition historique (low)'],
    'AMT_B3_max': AMT_df3['Répartition historique (high)'],
    'AMT_B3_RCP_median': AMT_df3['RCP 4.5 médiane'],
    'AMT_B3_RCP_min': AMT_df3['RCP 4.5 portée (low)'],
    'AMT_B3_RCP_max': AMT_df3['RCP 4.5 portée (high)'],
    'AMT_B4_mean': AMT_df4['Historique modélisé'],
    'AMT_B4_min': AMT_df4['Répartition historique (low)'],
    'AMT_B4_max': AMT_df4['Répartition historique (high)'],
    'AMT_B4_RCP_median': AMT_df4['RCP 4.5 médiane'],
    'AMT_B4_RCP_min': AMT_df4['RCP 4.5 portée (low)'],
    'AMT_B4_RCP_max': AMT_df4['RCP 4.5 portée (high)'],
    'ATP_B1_mean': ATP_df1['Historique modélisé'],
    'ATP_B1_min': ATP_df1['Répartition historique (low)'],
    'ATP_B1_max': ATP_df1['Répartition historique (high)'],
    'ATP_B1_RCP_median': ATP_df1['RCP 4.5 médiane'],
    'ATP_B1_RCP_min': ATP_df1['RCP 4.5 portée (low)'],
    'ATP_B1_RCP_max': ATP_df1['RCP 4.5 portée (high)'],
    'ATP_B2_mean': ATP_df2['Historique modélisé'],
    'ATP_B2_min': ATP_df2['Répartition historique (low)'],
    'ATP_B2_max': ATP_df2['Répartition historique (high)'],
    'ATP_B2_RCP_median': ATP_df2['RCP 4.5 médiane'],
    'ATP_B2_RCP_min': ATP_df2['RCP 4.5 portée (low)'],
    'ATP_B2_RCP_max': ATP_df2['RCP 4.5 portée (high)'],
    'ATP_B3_mean': ATP_df3['Historique modélisé'],
    'ATP_B3_min': ATP_df3['Répartition historique (low)'],
    'ATP_B3_max': ATP_df3['Répartition historique (high)'],
    'ATP_B3_RCP_median': ATP_df3['RCP 4.5 médiane'],
    'ATP_B3_RCP_min': ATP_df3['RCP 4.5 portée (low)'],
    'ATP_B3_RCP_max': ATP_df3['RCP 4.5 portée (high)'],
    'ATP_B4_mean': ATP_df4['Historique modélisé'],
    'ATP_B4_min': ATP_df4['Répartition historique (low)'],
    'ATP_B4_max': ATP_df4['Répartition historique (high)'],
    'ATP_B4_RCP_median': ATP_df4['RCP 4.5 médiane'],
    'ATP_B4_RCP_min': ATP_df4['RCP 4.5 portée (low)'],
    'ATP_B4_RCP_max': ATP_df4['RCP 4.5 portée (high)']
}, index=date_index_y)

#print(df)

########################################################################################################################

# Plots

#d = AMT_df1['DateTime'].values
d = pd.date_range(start='1985-01-01', end='2021-01-01', freq='Y').values

#print(d, d2)

fig = plt.figure(figsize=(12,12))
fig.suptitle('')
grid = plt.GridSpec(4, 7, wspace=0, hspace=0)

MNDVI_1985_1989 = fig.add_subplot(grid[2,0])
MNDVI_1990_1994 = fig.add_subplot(grid[2,1], sharey=MNDVI_1985_1989)
MNDVI_1995_1999 = fig.add_subplot(grid[2,2], sharey=MNDVI_1985_1989)
MNDVI_2000_2004 = fig.add_subplot(grid[2,3], sharey=MNDVI_1985_1989)
MNDVI_2005_2009 = fig.add_subplot(grid[2,4], sharey=MNDVI_1985_1989)
MNDVI_2010_2014 = fig.add_subplot(grid[2,5], sharey=MNDVI_1985_1989)
MNDVI_2015_2019 = fig.add_subplot(grid[2,6], sharey=MNDVI_1985_1989)

# CNDVI_1985_1989 = fig.add_subplot(grid[3,0], ylim=(-10, 110))
# CNDVI_1990_1994 = fig.add_subplot(grid[3,1], sharey=CNDVI_1985_1989)
# CNDVI_1995_1999 = fig.add_subplot(grid[3,2], sharey=CNDVI_1985_1989)
# CNDVI_2000_2004 = fig.add_subplot(grid[3,3], sharey=CNDVI_1985_1989)
# CNDVI_2005_2009 = fig.add_subplot(grid[3,4], sharey=CNDVI_1985_1989)
# CNDVI_2010_2014 = fig.add_subplot(grid[3,5], sharey=CNDVI_1985_1989)
# CNDVI_2015_2019 = fig.add_subplot(grid[3,6], sharey=CNDVI_1985_1989)

MNDMI_1985_1989 = fig.add_subplot(grid[3,0], ylim=(-0.27, 0.27))
MNDMI_1990_1994 = fig.add_subplot(grid[3,1], sharey=MNDMI_1985_1989)
MNDMI_1995_1999 = fig.add_subplot(grid[3,2], sharey=MNDMI_1985_1989)
MNDMI_2000_2004 = fig.add_subplot(grid[3,3], sharey=MNDMI_1985_1989)
MNDMI_2005_2009 = fig.add_subplot(grid[3,4], sharey=MNDMI_1985_1989)
MNDMI_2010_2014 = fig.add_subplot(grid[3,5], sharey=MNDMI_1985_1989)
MNDMI_2015_2019 = fig.add_subplot(grid[3,6], sharey=MNDMI_1985_1989)

# CNDWI_1985_1989 = fig.add_subplot(grid[5,0], ylim=(-5, 75))
# CNDWI_1990_1994 = fig.add_subplot(grid[5,1], sharey=CNDWI_1985_1989)
# CNDWI_1995_1999 = fig.add_subplot(grid[5,2], sharey=CNDWI_1985_1989)
# CNDWI_2000_2004 = fig.add_subplot(grid[5,3], sharey=CNDWI_1985_1989)
# CNDWI_2005_2009 = fig.add_subplot(grid[5,4], sharey=CNDWI_1985_1989)
# CNDWI_2010_2014 = fig.add_subplot(grid[5,5], sharey=CNDWI_1985_1989)
# CNDWI_2015_2019 = fig.add_subplot(grid[5,6], sharey=CNDWI_1985_1989)

AMT_plot = fig.add_subplot(grid[0,:])
ATP_plot = fig.add_subplot(grid[1,:], ylim=(501, 949)) #, sharex=AMT_plot

# Clustering subplot

# Mean NDVI
Mean_NDVI_1985_1989 = df_1985_1989.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_1985_1989, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_1985_1989.set_title('')
Mean_NDVI_1985_1989.set_xticks([], minor=True)
Mean_NDVI_1985_1989.set_ylabel("Mean NDVI")
Mean_NDVI_1985_1989.grid(axis='x')

Mean_NDVI_1990_1994 = df_1990_1994.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_1990_1994, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_1990_1994.set_title('')
Mean_NDVI_1990_1994.yaxis.set_tick_params(which='major', left=False)
Mean_NDVI_1990_1994.grid(axis='x')

Mean_NDVI_1995_1999 = df_1995_1999.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_1995_1999, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_1995_1999.set_title('')
Mean_NDVI_1995_1999.yaxis.set_tick_params(which='major', left=False)
Mean_NDVI_1995_1999.grid(axis='x')

Mean_NDVI_2000_2004 = df_2000_2004.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_2000_2004, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_2000_2004.set_title('')
Mean_NDVI_2000_2004.yaxis.set_tick_params(which='major', left=False)
Mean_NDVI_2000_2004.grid(axis='x')

Mean_NDVI_2005_2009 = df_2005_2009.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_2005_2009, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_2005_2009.set_title('')
Mean_NDVI_2005_2009.yaxis.set_tick_params(which='major', left=False)
Mean_NDVI_2005_2009.grid(axis='x')

Mean_NDVI_2010_2014 = df_2010_2014.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_2010_2014, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_2010_2014.set_title('')
Mean_NDVI_2010_2014.yaxis.set_tick_params(which='major', left=False)
Mean_NDVI_2010_2014.grid(axis='x')

Mean_NDVI_2015_2019 = df_2015_2019.boxplot(by="Cluster", column=["Mean\nNDVI"], ax=MNDVI_2015_2019, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDVI_2015_2019.set_title('')
Mean_NDVI_2015_2019.yaxis.set_tick_params(which='major', left=False)
Mean_NDVI_2015_2019.grid(axis='x')

orange_patch = mpatches.Patch(color='blue', label='Cluster 1')
blue_patch = mpatches.Patch(color='orange', label='Cluster 2')
Mean_NDVI_2015_2019.legend(handles=[orange_patch, blue_patch], loc= 'lower right', bbox_to_anchor=(1, -0.02))

# NDVI cover
# Cover_NDVI_1985_1989 = df_1985_1989.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_1985_1989, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_1985_1989.set_title('')
# Cover_NDVI_1985_1989.set_xticks([], minor=True)
# Cover_NDVI_1985_1989.set_ylabel("NDVI fractional\ncoverage (%)")
# Cover_NDVI_1985_1989.grid(axis='x')
#
# Cover_NDVI_1990_1994 = df_1990_1994.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_1990_1994, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_1990_1994.set_title('')
# Cover_NDVI_1990_1994.yaxis.set_tick_params(which='major', left=False)
# Cover_NDVI_1990_1994.grid(axis='x')
#
# Cover_NDVI_1995_1999 = df_1995_1999.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_1995_1999, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_1995_1999.set_title('')
# Cover_NDVI_1995_1999.yaxis.set_tick_params(which='major', left=False)
# Cover_NDVI_1995_1999.grid(axis='x')
#
# Cover_NDVI_2000_2004 = df_2000_2004.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_2000_2004, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_2000_2004.set_title('')
# Cover_NDVI_2000_2004.yaxis.set_tick_params(which='major', left=False)
# Cover_NDVI_2000_2004.grid(axis='x')
#
# Cover_NDVI_2005_2009 = df_2005_2009.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_2005_2009, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_2005_2009.set_title('')
# Cover_NDVI_2005_2009.yaxis.set_tick_params(which='major', left=False)
# Cover_NDVI_2005_2009.grid(axis='x')
#
# Cover_NDVI_2010_2014 = df_2010_2014.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_2010_2014, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_2010_2014.set_title('')
# Cover_NDVI_2010_2014.yaxis.set_tick_params(which='major', left=False)
# Cover_NDVI_2010_2014.grid(axis='x')
#
# Cover_NDVI_2015_2019 = df_2015_2019.boxplot(by="Cluster", column=["NDVI fractional\ncoverage (%)"], ax=CNDVI_2015_2019, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDVI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDVI_2015_2019.set_title('')
# Cover_NDVI_2015_2019.yaxis.set_tick_params(which='major', left=False)
# Cover_NDVI_2015_2019.grid(axis='x')

# Mean NDMI
Mean_NDMI_1985_1989 = df_1985_1989.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_1985_1989, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_1985_1989.set_title('')
Mean_NDMI_1985_1989.set_xticks([], minor=True)
Mean_NDMI_1985_1989.set_ylabel("Mean NDMI")
Mean_NDMI_1985_1989.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_1985_1989.set_xlabel("1985-1989")
Mean_NDMI_1985_1989.grid(axis='x')

Mean_NDMI_1990_1994 = df_1990_1994.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_1990_1994, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_1990_1994.set_title('')
Mean_NDMI_1990_1994.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_1990_1994.yaxis.set_tick_params(which='major', left=False)
Mean_NDMI_1990_1994.set_xlabel("1990-1994")
Mean_NDMI_1990_1994.grid(axis='x')

Mean_NDMI_1995_1999 = df_1995_1999.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_1995_1999, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_1995_1999.set_title('')
Mean_NDMI_1995_1999.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_1995_1999.yaxis.set_tick_params(which='major', left=False)
Mean_NDMI_1995_1999.set_xlabel("1995-1999")
Mean_NDMI_1995_1999.grid(axis='x')

Mean_NDMI_2000_2004 = df_2000_2004.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_2000_2004, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_2000_2004.set_title('')
Mean_NDMI_2000_2004.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_2000_2004.yaxis.set_tick_params(which='major', left=False)
Mean_NDMI_2000_2004.set_xlabel("2000-2004")
Mean_NDMI_2000_2004.grid(axis='x')

Mean_NDMI_2005_2009 = df_2005_2009.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_2005_2009, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_2005_2009.set_title('')
Mean_NDMI_2005_2009.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_2005_2009.yaxis.set_tick_params(which='major', left=False)
Mean_NDMI_2005_2009.set_xlabel("2005-2009")
Mean_NDMI_2005_2009.grid(axis='x')

Mean_NDMI_2010_2014 = df_2010_2014.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_2010_2014, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_2010_2014.set_title('')
Mean_NDMI_2010_2014.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_2010_2014.yaxis.set_tick_params(which='major', left=False)
Mean_NDMI_2010_2014.set_xlabel("2010-2014")
Mean_NDMI_2010_2014.grid(axis='x')

Mean_NDMI_2015_2019 = df_2015_2019.boxplot(by="Cluster", column=["Mean\nNDMI"], ax=MNDMI_2015_2019, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
Mean_NDMI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
Mean_NDMI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
Mean_NDMI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
Mean_NDMI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
Mean_NDMI_2015_2019.set_title('')
Mean_NDMI_2015_2019.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
Mean_NDMI_2015_2019.yaxis.set_tick_params(which='major', left=False)
Mean_NDMI_2015_2019.set_xlabel("2015-2019")
Mean_NDMI_2015_2019.grid(axis='x')

# NDWI Cover
# Cover_NDWI_1985_1989 = df_1985_1989.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_1985_1989, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_1985_1989.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_1985_1989.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_1985_1989.set_title('')
# Cover_NDWI_1985_1989.set_xticks([], minor=True)
# Cover_NDWI_1985_1989.set_ylabel("NDWI fractional\ncoverage (%)")
# Cover_NDWI_1985_1989.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_1985_1989.set_xlabel("1985-1989")
# Cover_NDWI_1985_1989.grid(axis='x')
#
# Cover_NDWI_1990_1994 = df_1990_1994.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_1990_1994, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_1990_1994.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_1990_1994.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_1990_1994.set_title('')
# Cover_NDWI_1990_1994.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_1990_1994.yaxis.set_tick_params(which='major', left=False)
# Cover_NDWI_1990_1994.set_xlabel("1990-1994")
# Cover_NDWI_1990_1994.grid(axis='x')
#
# Cover_NDWI_1995_1999 = df_1995_1999.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_1995_1999, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_1995_1999.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_1995_1999.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_1995_1999.set_title('')
# Cover_NDWI_1995_1999.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_1995_1999.yaxis.set_tick_params(which='major', left=False)
# Cover_NDWI_1995_1999.set_xlabel("1995-1999")
# Cover_NDWI_1995_1999.grid(axis='x')
#
# Cover_NDWI_2000_2004 = df_2000_2004.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_2000_2004, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_2000_2004.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_2000_2004.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_2000_2004.set_title('')
# Cover_NDWI_2000_2004.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_2000_2004.yaxis.set_tick_params(which='major', left=False)
# Cover_NDWI_2000_2004.set_xlabel("2000-2004")
# Cover_NDWI_2000_2004.grid(axis='x')
#
# Cover_NDWI_2005_2009 = df_2005_2009.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_2005_2009, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_2005_2009.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_2005_2009.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_2005_2009.set_title('')
# Cover_NDWI_2005_2009.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_2005_2009.yaxis.set_tick_params(which='major', left=False)
# Cover_NDWI_2005_2009.set_xlabel("2005-2009")
# Cover_NDWI_2005_2009.grid(axis='x')
#
# Cover_NDWI_2010_2014 = df_2010_2014.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_2010_2014, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_2010_2014.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_2010_2014.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_2010_2014.set_title('')
# Cover_NDWI_2010_2014.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_2010_2014.yaxis.set_tick_params(which='major', left=False)
# Cover_NDWI_2010_2014.set_xlabel("2010-2014")
# Cover_NDWI_2010_2014.grid(axis='x')
#
# Cover_NDWI_2015_2019 = df_2015_2019.boxplot(by="Cluster", column=["NDWI fractional\ncoverage (%)"], ax=CNDWI_2015_2019, patch_artist=True, medianprops=dict(color='k'), whiskerprops=dict(color='k')) # add boxplot to 1st subplot
# Cover_NDWI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_edgecolor("blue")
# Cover_NDWI_2015_2019.findobj(matplotlib.patches.Patch)[0].set_facecolor("None")
# Cover_NDWI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_edgecolor("orange")
# Cover_NDWI_2015_2019.findobj(matplotlib.patches.Patch)[1].set_facecolor("None")
# Cover_NDWI_2015_2019.set_title('')
# Cover_NDWI_2015_2019.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
# Cover_NDWI_2015_2019.yaxis.set_tick_params(which='major', left=False)
# Cover_NDWI_2015_2019.set_xlabel("2015-2019")
# Cover_NDWI_2015_2019.grid(axis='x')

plt.suptitle('')

# Mean Annual Temperature subplot
df.plot(y='AMT_B1_mean', style='-', color='orange', label='Lower George\nHistorical', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B1_max'], df['AMT_B1_min'], facecolor='orange', alpha=0.2)
df.plot(y='AMT_B1_RCP_median', style='--', color='orange', label='Lower George\nRCP 4.5', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B1_RCP_max'], df['AMT_B1_RCP_min'], facecolor='orange', alpha=0.1)

df.plot(y='AMT_B2_mean', style='-', color='#005fcc', label='Upper George 1\nHistorical', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B2_max'], df['AMT_B2_min'], facecolor='#005fcc', alpha=0.2)
df.plot(y='AMT_B2_RCP_median', style='--', color='#005fcc', label='Upper George 1\nRCP 4.5', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B2_RCP_max'], df['AMT_B2_RCP_min'], facecolor='#005fcc', alpha=0.1)

df.plot(y='AMT_B3_mean', style='-', color='#00489e', label='Upper George 2\nHistorical', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B3_max'], df['AMT_B3_min'], facecolor='#00489e', alpha=0.2)
df.plot(y='AMT_B3_RCP_median', style='--', color='#00489e', label='Upper George 2\nRCP 4.5', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B3_RCP_max'], df['AMT_B3_RCP_min'], facecolor='#00489e', alpha=0.1)

df.plot(y='AMT_B4_mean', style='-', color='#00306f', label='Upper George 3\nHistorical', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B4_max'], df['AMT_B4_min'], facecolor='#00306f', alpha=0.2)
df.plot(y='AMT_B4_RCP_median', style='--', color='#00306f', label='Upper George 3\nRCP 4.5', ax=AMT_plot)
AMT_plot.fill_between(d, df['AMT_B4_RCP_max'], df['AMT_B4_RCP_min'], facecolor='#00306f', alpha=0.1)

AMT_plot.grid(which='minor', axis='both')
AMT_plot.grid(which='major', axis='x', color='black')
AMT_plot.grid(which='major', axis='y')

AMT_plot.xaxis.set_tick_params(which='both', top=True, labeltop=True, labelbottom=False)

AMT_plot.set_ylabel("Mean Annual\nTemperature (C°)")
AMT_plot.legend_.remove()

# Total Annual Precipitation subplot
df.plot(y='ATP_B1_mean', style='-', color='orange', label='Lower George\nHistorical', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B1_max'], df['ATP_B1_min'], facecolor='orange', alpha=0.2)
df.plot(y='ATP_B1_RCP_median', style='--', color='orange', label='Lower George\nRCP 4.5', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B1_RCP_max'], df['ATP_B1_RCP_min'], facecolor='orange', alpha=0.1)

df.plot(y='ATP_B2_mean', style='-', color='#005fcc', label='Upper George 1\nHistorical', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B2_max'], df['ATP_B2_min'], facecolor='#005fcc', alpha=0.2)
df.plot(y='ATP_B2_RCP_median', style='--', color='#005fcc', label='Upper George 1\nRCP 4.5', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B2_RCP_max'], df['ATP_B2_RCP_min'], facecolor='#005fcc', alpha=0.1)

df.plot(y='ATP_B3_mean', style='-', color='#00489e', label='Upper George 2\nHistorical', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B3_max'], df['ATP_B3_min'], facecolor='#00489e', alpha=0.2)
df.plot(y='ATP_B3_RCP_median', style='--', color='#00489e', label='Upper George 2\nRCP 4.5', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B3_RCP_max'], df['ATP_B3_RCP_min'], facecolor='#00489e', alpha=0.1)

df.plot(y='ATP_B4_mean', style='-', color='#00306f', label='Upper George 3\nHistorical', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B4_max'], df['ATP_B4_min'], facecolor='#00306f', alpha=0.2)
df.plot(y='ATP_B4_RCP_median', style='--', color='#00306f', label='Upper George 3\nRCP 4.5', ax=ATP_plot)
ATP_plot.fill_between(d, df['ATP_B4_RCP_max'], df['ATP_B4_RCP_min'], facecolor='#00306f', alpha=0.1)

ATP_plot.grid(which='minor', axis='both')
ATP_plot.grid(which='major', axis='x', color='black')
ATP_plot.grid(which='major', axis='y')

ATP_plot.xaxis.set_tick_params(which='both', bottom=False, labelbottom=False)
#ATP_plot.xaxis.set_tick_params()

ATP_plot.set_ylabel("Total Annual\nPrecipitation (mm)")
ATP_plot.legend(loc='lower right', ncol=4, bbox_to_anchor=(1, 0.8))#, borderaxespad=0.5)

plt.savefig('Trends.png', dpi=300)

########################################################################################################################
# Membership coefficient trends

periods = ['_1985_1989', '_1990_1994', '_1995_1999', '_2000_2004', '_2005_2009', '_2010_2014', '_2015_2019']
periods_df = pd.DataFrame({
    'Period' : [1985, 1990, 1995, 2000, 2005, 2010, 2015]
})

Membership1_df = pd.DataFrame()
Mem1Trend_df = pd.DataFrame()

for i in AT_fn_list :
    df = pd.read_csv(i)
    Membership1_df['Membership'+periods[AT_fn_list.index(i)]] = df['Membership1']

for i, row in Membership1_df.iloc[0:,:].iterrows():
    r = scipy.stats.linregress(periods_df['Period'], row)
    Mem1Trend_df = pd.concat([Mem1Trend_df, pd.DataFrame(r._asdict(), index=[i])])

# saving the dataframe
Mem1Trend_df.to_csv('Mem1Trend.csv')

Membership2_df = pd.DataFrame()
Mem2Trend_df = pd.DataFrame()

for i in AT_fn_list :
    df = pd.read_csv(i)
    Membership2_df['Membership'+periods[AT_fn_list.index(i)]] = df['Membership2']

for i, row in Membership2_df.iloc[0:,:].iterrows():
    r = scipy.stats.linregress(periods_df['Period'], row)
    Mem2Trend_df = pd.concat([Mem2Trend_df, pd.DataFrame(r._asdict(), index=[i])])

# saving the dataframe
Mem2Trend_df.to_csv('Mem2Trend.csv')

########################################################################################################################
# Mean NDVI trends

MeanNDVI_df = pd.DataFrame()
MeanNDVITrend_df = pd.DataFrame()

for i in AT_fn_list :
    df = pd.read_csv(i)
    MeanNDVI_df['Mean_NDVI'+periods[AT_fn_list.index(i)]] = df['NDVI_mean']

for i, row in MeanNDVI_df.iloc[0:,:].iterrows():
    r = scipy.stats.linregress(periods_df['Period'], row)
    MeanNDVITrend_df = pd.concat([MeanNDVITrend_df, pd.DataFrame(r._asdict(), index=[i])])

# saving the dataframe
MeanNDVITrend_df.to_csv('MeanNDVITrend.csv')

########################################################################################################################
# Vegetated Landscape (%) trends

NDVIcover_df = pd.DataFrame()
NDVIcoverTrend_df = pd.DataFrame()

for i in AT_fn_list :
    df = pd.read_csv(i)
    NDVIcover_df['NDVIcover'+periods[AT_fn_list.index(i)]] = df['NDVI_veg_cover']

for i, row in NDVIcover_df.iloc[0:,:].iterrows():
    r = scipy.stats.linregress(periods_df['Period'], row)
    NDVIcoverTrend_df = pd.concat([NDVIcoverTrend_df, pd.DataFrame(r._asdict(), index=[i])])

# saving the dataframe
NDVIcoverTrend_df.to_csv('NDVIcoverTrend.csv')

########################################################################################################################
# Mean NDWI trends

MeanNDWI_df = pd.DataFrame()
MeanNDWITrend_df = pd.DataFrame()

for i in AT_fn_list :
    df = pd.read_csv(i)
    MeanNDWI_df['Mean_NDMI'+periods[AT_fn_list.index(i)]] = df['NDMI_mean']

for i, row in MeanNDWI_df.iloc[0:,:].iterrows():
    r = scipy.stats.linregress(periods_df['Period'], row)
    MeanNDWITrend_df = pd.concat([MeanNDWITrend_df, pd.DataFrame(r._asdict(), index=[i])])

# saving the dataframe
MeanNDWITrend_df.to_csv('MeanNDMITrend.csv')

########################################################################################################################
# Submerged Landscape (%) trends

NDWIcover_df = pd.DataFrame()
NDWIcoverTrend_df = pd.DataFrame()

for i in AT_fn_list :
    df = pd.read_csv(i)
    NDWIcover_df['NDWIcover'+periods[AT_fn_list.index(i)]] = df['NDWI_water_cover']

for i, row in NDWIcover_df.iloc[0:,:].iterrows():
    r = scipy.stats.linregress(periods_df['Period'], row)
    NDWIcoverTrend_df = pd.concat([NDWIcoverTrend_df, pd.DataFrame(r._asdict(), index=[i])])

# saving the dataframe
NDWIcoverTrend_df.to_csv('NDWIcoverTrend.csv')
